Attribute VB_Name = "PRINTFIL1"
Option Explicit
'
Public FileNome$            ' Nome Completo del File da Stampare.
Public FileTitl$            ' Nome del File da Stampare.
Public DriveNome$           ' Drive in uso di Default.
Public DirNome$             ' Directory in uso di Default.
Public PrinterNome$         ' Nome della stampante di Applicazione.
'Public WinDir$              ' Directory di Windows.
'
'
Private Const LBuf& = 1000  ' < 32768 [bytes].
Private Buffer(1 To LBuf + 2) As Byte
'
Public CHIUDI_A As Boolean  ' Abilitazione alla chiusura del Form.
Public STAMPA_A As Boolean  ' Abilitazione Stampa.
Public DimFile&             ' Dimensione del File [bytes].
Public hdc&
Public prhDC&
Public hPrinter&            ' Identificatore del Job di stampa.
Public JobId&
'
Private Const PASSTHROUGH& = 19
Private Const SP_ERROR& = (-1)
'
Type DOC_INFO    ' 12 Bytes
   cbSize As Long
   lpszDocName As String
   lpszOutput As String
End Type
'
Declare Function StartDoc& Lib "gdi32" _
Alias "StartDocA" (ByVal hPrinter As Long, lpdi As DOC_INFO)
Private Declare Function StartPage Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function EndPage Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function EndDocAPI& Lib "gdi32" _
Alias "EndDoc" (ByVal hPrinter As Long)
Public Declare Function AbortDoc& Lib "gdi32" (ByVal hPrinter As Long)
Declare Function Escape& Lib "gdi32" (ByVal hPrinter As Long _
, ByVal nEscape As Long, ByVal nCount As Long _
, lpInData As Any, lpOutData As Any)
'   Nota: contrariamente a quanto scritto nel libro API Book,
'   solo i primi due Bytes di lpInData devono contenere il numero
'   dei dati successivi.
'
Private Declare Function CreateDCBynum Lib "gdi32" Alias "CreateDCA" _
(ByVal lpDriverName As String, ByVal lpDeviceName As String _
, ByVal lpOutput As String, ByVal lpInitData As Long) As Long
'
Declare Function AbortPrinter& Lib "spoolss.dll" (ByVal hPrinter As Long)
Private Declare Function GetEnvironmentVariable Lib "kernel32" _
Alias "GetEnvironmentVariableA" (ByVal lpname As String _
, ByVal lpBuffer As String, ByVal nSize As Long) As Long
'
'
Private Type DOC_INFO_1
    pDocName As String
    pOutputFile As String
    pDatatype As String
End Type
'
Private Declare Function OpenPrinter& Lib "winspool.drv" _
Alias "OpenPrinterA" (ByVal pPrinterName As String, phPrinter As Long _
, ByVal pDefault As Long) ' Third param changed to long
Private Declare Function StartDocPrinter& Lib "winspool.drv" _
Alias "StartDocPrinterA" (ByVal hPrinter As Long, ByVal Level As Long _
, pDocInfo As DOC_INFO_1)
Private Declare Function StartPagePrinter& Lib "winspool.drv" _
(ByVal hPrinter As Long)
Private Declare Function WritePrinter& Lib "winspool.drv" _
(ByVal hPrinter As Long, pBuf As Any, ByVal cdBuf As Long _
, pcWritten As Long)
Private Declare Function EndDocPrinter& Lib "winspool.drv" _
(ByVal hPrinter As Long)
Private Declare Function EndPagePrinter& Lib "winspool.drv" _
(ByVal hPrinter As Long)
Private Declare Function ClosePrinter& Lib "winspool.drv" _
(ByVal hPrinter As Long)
'
Private Declare Function GetProfileString& Lib "kernel32" _
Alias "GetProfileStringA" (ByVal lpAppName As String _
, ByVal lpKeyName As String, ByVal lpDefault As String _
, ByVal lpReturnedString As String, ByVal nSize As Long)
Private Declare Function agGetStringFromLPSTR$ Lib "apigid32.dll" _
(ByVal Src$)
Public Function GetSystemInfo$(ByVal Info$)
'
'
    Dim dl&, BUF$
'
    On Error GoTo GetSystemInfo_ERR
'
    BUF$ = String$(2048, 0)
    dl& = GetEnvironmentVariable(Info$, BUF$, 2047)
    If dl& > 0 Then
        GetSystemInfo$ = Left$(BUF$, dl&)
    Else
        GetSystemInfo$ = ""
    End If
'
    Exit Function
'
GetSystemInfo_ERR:
    GetSystemInfo$ = ""
'
'
'
End Function

Private Sub ValToBytes(ByVal Valore&, ByVal n&, Vettore() As Byte)
'
'   Divide Valore& in n [bytes] successivi su Vettore().
'
    Dim I&
'
    Vettore(1) = Valore And &HFF
    'Valore = (Valore And &HFFFFFF00) / &H100
    'Vettore(2) = Valore And &HFF
    For I = 2 To n
        Valore = (Valore And &HFFFFFF00) / &H100
        Vettore(I) = Valore And &HFF
    Next I
'
'
'
End Sub

Private Function GetDefPrinterName$()
'
'   Ritorna il nome della stampante di default del sistema.
'
    Dim def$, R1&, npos&
'
    def$ = String$(128, 0)
    R1 = GetProfileString("WINDOWS", "DEVICE", "", def$, 127)
    def$ = agGetStringFromLPSTR$(def$)
'
    npos = InStr(def$, ",")
    GetDefPrinterName$ = Left$(def$, npos - 1)
'
'
'
End Function

Public Function BreakDown(ByVal Full$, ByRef PName$ _
    , Optional ByRef FName$, Optional ByRef Ext$) As Boolean
'
'   Scompone un nome di File completo di Path nelle sue parti:
'   Full$  = Nome completo del File.
'   PName$ = Path del File.
'   FName$ = Nome del File con Estensione.
'   Ext$   = .Estensione del File.
'
'   Se il File non esiste scompone il nome e ritorna False.
'
    Dim Sloc&, Dot&
'
    BreakDown = FileExists(Full$)
'
    If InStr(Full$, "\") Then
        FName$ = Full$
        PName$ = ""
        Sloc = InStr(FName$, "\")
        Do While Sloc <> 0
            PName$ = PName$ + Left$(FName$, Sloc)
            FName$ = Mid$(FName$, Sloc + 1)
            Sloc = InStr(FName$, "\")
        Loop
    Else
        PName$ = ""
        FName$ = Full$
    End If
'
    Dot = InStr(Full$, ".")
    If Dot <> 0 Then
        Ext$ = Mid$(Full$, Dot)
    Else
        Ext$ = ""
    End If
'
'
'
End Function

Function FileExists(ByVal path$) As Boolean
'
'-----------------------------------------------------------
'   Check for the existence of a file by attempting an OPEN.
'-----------------------------------------------------------
'
    Dim FF%
'
    On Error Resume Next
'
    FF = FreeFile
    Open path$ For Input As #FF
    FileExists = (Err = 0)
    Close #FF
'
'
'
End Function

Sub Main()
'
'
    Dim P&, C$, FF%
'
    'WinDir$ = GetSystemInfo$("windir")
    PrinterNome$ = GetDefPrinterName$()
    DirNome$ = "C:\Temp"
'
    With frmPrintFil
    .Show
    .Refresh
    DoEvents
'
    If Command <> "" Then
        FileNome$ = Command    ' Legge il nome del File iniziale.
        If Left$(FileNome$, 1) = Chr$(34) Then
            ' Elimina da "FileNome$" le virgolette iniziali e finali:
            FileNome$ = Mid$(FileNome$, 2, Len(FileNome$) - 2)
        End If
        If BreakDown(FileNome$, DirNome$, FileTitl$) Then
            FF = FreeFile
            Open FileNome$ For Binary As #FF
            DimFile = LOF(FF)
            Close (FF)
            .lblDimFile = Format(DimFile, "###,###,###")
            .txtFileNome.Text = FileNome$
            .cmdStampa.Enabled = True
            .mnuStampa.Enabled = True
            .cmdStampa.SetFocus
        End If
    End If
    End With
'
'
'
End Sub

Sub PRINT_B()
'
'
    Dim FF%, LF&, UPC&, A$, n&
'
    'frmPrintFil.MENU_FILE.Enabled = False
    frmPrintFil.Height = 5235
    frmPrintFil.MousePointer = 11
'
    FF = FreeFile
    Open FileNome$ For Binary As #FF
    LF = LOF(FF)
    UPC = LF / 1000
    Close #FF
'
    'frmPrintFil.LAVORO_LBL.FontSize = 12
    A$ = "Stampa di " + FileTitl$ + " in corso  ("
    A$ = A$ + Trim$(Str$(Int(LF& / 1000))) + " " + "KBytes)"
    'frmPrintFil.LAVORO_LBL.Caption = A$
    'frmPrintFil.LAVORO_LBL.Refresh
    'frmPrintFil.QUADRO_PIC.Visible = True
'
    Dim DefaultPrinter As String  'hold the default printer information.
    Dim Driver As String          'holds driver name.
    Dim port As String            'holds printer port of driver.
    Dim FileToSpool As String     'name of file we are going to print.
    Dim ret As Long               'return value of API calls.
    Dim hdc As Long               'return value of API calls.
'
    'initialize our printer buffer, call the API, and trim the Nulls:
    DefaultPrinter = Space$(128)
    ret = GetProfileString("windows", "device", "NONE", DefaultPrinter, Len(DefaultPrinter))
    DefaultPrinter = Left$(DefaultPrinter, ret)
'
    'parse the printer line for the port,
    'look for the second comma, this is where the port is
    'for the printer driver, take the string up to the first comma:
    Driver = Left$(DefaultPrinter, InStr(DefaultPrinter, ",") - 1)
    port = Mid$(DefaultPrinter, InStr(Len(Driver) + 2, DefaultPrinter, ",") + 1)
'
    'copy our data file and print the copy - SpoolFile will DELETE it!
    FileToSpool = "c:\toprintr.prn"
    FileCopy FileNome$, FileToSpool
'
    'spool the file to the PrintManager:
    'hdc = SpoolFile(Driver, port, FileTitl$ & " - Spooling File", FileToSpool)
'
    'check for errors values in the Win 3.1 SDK help file:
    If ((hdc < -5) Or (hdc > 0)) And (hdc <> &H4000) Then
        n& = Int(Timer)
        'loop until print job done:
        'While GetModuleUsage(hdc) > 0
            If Int(Timer) > n& Then
            'If Int(10 * Timer) Mod 10 = 0 Then
                'frmPrintFil.QUADRO_PIC.Circle (RANDU(0, 100), RANDU(0, 100)), RANDU(1, 15), QBColor(RANDU(1, 15))
                n = Int(Timer)
            End If
            DoEvents
        'Wend
        'If frmPrintFil.CANCELLA_FILE_CKB Then Kill FileNome$
    Else
        MsgBox "Error on print: (" & CStr(hdc) & ")", 16
    End If
'
    frmPrintFil.Height = 2325
    'frmPrintFil.QUADRO_PIC.Cls
    'frmPrintFil.QUADRO_PIC.Visible = False
    'frmPrintFil.MENU_FILE.Enabled = True
    'frmPrintFil.LAVORO_LBL.Caption = ""
    frmPrintFil.MousePointer = 0
'
'
'
End Sub

Function RANDU(ByVal MIN!, ByVal MAX!) As Single
'
'
    RANDU = MIN + Rnd * (MAX - MIN)
'
'
'
End Function

Sub STAMPA(ByVal FileNome$)
'
'   Stampa il File.
'
    On Error GoTo ERR_STAMPA
'
    If FileExists(FileNome$) Then
        Call PRINT_B
    Else
        MsgBox "Il File indicato non esiste !!!", 16, "Errore"
    End If
'
'
'
    Exit Sub
'
ERR_STAMPA:
    MsgBox Error$, 16, "Errore in STAMPA"
    Exit Sub
'
'
'
End Sub


Public Sub Print_A()
'
'
    Dim JobId&, written&
    Dim res&, DocInfo As DOC_INFO_1
    Dim PrintData$, LF&
    Dim FF%, B As Byte, Nc&

    res = OpenPrinter(PrinterNome$, hPrinter, 0)
    If res = 0 Then
        MsgBox "Unable to open the printer"
        Exit Sub
    End If
    DocInfo.pDocName = "Stampa del file " + FileTitl$
    DocInfo.pOutputFile = vbNullString
    DocInfo.pDatatype = vbNullString
    If StartDocPrinter(hPrinter, 1, DocInfo) = 0 Then MsgBox "Err StartDocPrinter"
    'Call StartPagePrinter(hPrinter)
'
    FF = FreeFile
    Open FileNome$ For Binary As #FF
    LF = LOF(FF)
    frmPrintFil.lblDimFile = Format((CSng(LF) / 1000000!), "###.000")
    'GoTo ll
'
    Nc = 0
    Do While Not EOF(FF)
        Get #FF, , B
        PrintData$ = PrintData$ + Chr$(B)
        Nc = Nc + 1
        If Nc Mod 1000 = 0 Then
            Call WritePrinter(hPrinter _
            , ByVal PrintData$, Len(PrintData$), written)
            PrintData$ = ""
            frmPrintFil.ProgressBar1.Value = (Nc / LF) * 100
            DoEvents
        End If
        If Not STAMPA_A Then Exit Do
     Loop
ll: Close (FF)
'
    'Call EndPagePrinter(hPrinter)
    If EndDocPrinter(hPrinter) = 0 Then MsgBox "Err EndDocPrinter"
    'If Not STAMPA_A Then res = AbortDoc(hPrinter)
    Call ClosePrinter(hPrinter) ' Close when done
'
'
'
End Sub

Public Sub Print_C()
'
'
    Dim res&, docname$, dinfo As DOC_INFO
    Dim FF%, B As Byte, Nc&, Nb&
'
    prhDC = CreateDCBynum("WINSPOOL", PrinterNome$, vbNullString, 0)
    docname$ = "Stampa del file: " + FileTitl$
    dinfo.cbSize = Len(dinfo)
    dinfo.lpszDocName = docname$
    dinfo.lpszOutput = vbNullString
'
    JobId = StartDoc(prhDC, dinfo)
    If JobId = SP_ERROR Then
        MsgBox "Err StartDoc", vbCritical
        Exit Sub
    Else
        'res = StartPage(prhDC)
    End If
'
    FF = FreeFile
    Open FileNome$ For Binary As #FF
'
    Nb = 0
    Nc = 0
    Do While Not EOF(FF)
        Nb = Nb + 1
        Nc = Nc + 1
'
        Get #FF, , B
        Buffer(Nb + 2) = B
        If Nb = LBuf Then
            ValToBytes Nb, 2, Buffer()
            res = Escape(prhDC, PASSTHROUGH, Nb, Buffer(1), 0)
            If res <= 0 Then
                MsgBox "Err Escape", vbCritical
                STAMPA_A = False
                Exit Do
            End If
            Nb = 0
            frmPrintFil.ProgressBar1.Value = (Nc / DimFile) * 100
            DoEvents
        End If
        If Not STAMPA_A Then Exit Do
     Loop
    If Nb > 0 And STAMPA_A Then
        ValToBytes Nb, 2, Buffer()
        res = Escape(prhDC, PASSTHROUGH, Nb, Buffer(1), 0)
        'frmPrintFil.ProgressBar1.Value = (Nc / DimFile) * 100
    End If
    Close (FF)
'
    'res = EndPage(prhDC)
    If STAMPA_A Then
        res = EndDocAPI(prhDC)
    Else
        res = AbortDoc(prhDC)
    End If
'
'
'
End Sub
